import java.lang.reflect.Field;
import java.io.*;
import java.util.*;

public class ComputeKernel
{
  public native float[][] start(float[][]data, float t, float stdv);

  public static void writeDat(String filename, float[] x, float[] y,
                                int xprecision, int yprecision)
        throws IOException {
        assert x.length == y.length;
        PrintWriter out = new PrintWriter(filename);
        for (int i = 0; i < x.length; i++)
            out.printf("%."+xprecision+"f %."+yprecision+"f\n", x[i], y[i]);
        out.close();
  }

  public static void main(String[] args) throws Exception
  {
//	String strFilePath = "/home/yanzheng/competitor_back/apmc/circle_line.txt";
  	String strFilePath = "/uusoc/scratch/mpserv1/yanzheng/CTEST/usa10morg";  	
	Scanner scanner = new Scanner(new File(strFilePath));
	int nPoints = 10019882;
    float[][] data = new float[nPoints][2];

    System.out.println("Read float: ");
    for (int i=0; i<nPoints; i++){
      for (int j=0; j<2; j++){
        data[i][j] = scanner.nextFloat();
		//System.out.println("i= "+i+" j="+j+" a[i][j]="+data[i][j]);
	  }
	}

	if( args.length < 1 ) {
       System.out.println( "Use: <absolute/path/to/library/>" );
       return;
    }
	/*
	float[][] data = new float[1000000][2];
	for(int i = 0; i<1000000; i = i+1){
		for(int j = 0; j<2; j = j+1){
			data[i][j] = (float)0.2;
		}
	}*/
	float t = (float)0.1;
	float stdv = 200;
    System.load(args[0] + "libKDEGrid.so");
    ComputeKernel myLib = new ComputeKernel();
	//HadoopKernel myLib = new HadoopKernel();
    float[][]sample = myLib.start(data, t, stdv);
	float[] x = new float[sample.length];
    float[] y = new float[sample.length];
	System.out.println( "After call the lib" );
    for(int i = 0; i<sample.length; i = i+1){
            x[i] = sample[i][0];
            y[i] = sample[i][1];
    }
    System.out.println( "Write Data" );
    try {
            writeDat("sample_naive_java.dat", x,y,6,6);
    } catch (IOException e) {
            System.err.println("writeDat: exception: "+e);
    }

  }
}
