package org.myorg;

import java.io.*;
import org.apache.hadoop.io.*;

public class SummaryContainer implements Writable {

  public DoubleArrayWritable buffer;
  public IntWritable numLayers;
  public DoubleArrayWritable[] layers;

  public SummaryContainer() {
     buffer = new DoubleArrayWritable();
     numLayers = new IntWritable();
     layers = new DoubleArrayWritable[0];
  }

  public SummaryContainer(DoubleArrayWritable inbuf, DoubleArrayWritable[] inlay) {
     buffer = new DoubleArrayWritable( (DoubleWritable[]) inbuf.get() );
     numLayers = new IntWritable( inlay.length );
     layers = new DoubleArrayWritable[numLayers.get()];     

     for( int i = 0; i < inlay.length; ++i )
        layers[i] = new DoubleArrayWritable( (DoubleWritable[]) inlay[i].get() );
  }

  public void write(DataOutput out) throws IOException {
     buffer.write(out);
     numLayers.write(out);
     for( int i = 0; i < layers.length; ++i ) {
        layers[i].write(out);
     }
  }
  
  public void readFields(DataInput in) throws IOException {
    buffer.readFields(in);
    numLayers.readFields(in);
    layers = new DoubleArrayWritable[numLayers.get()];

    for( int i = 0; i < layers.length; ++i ) {
       layers[i] = new DoubleArrayWritable();
       layers[i].readFields(in);
    }
  }
}

