package sort;
import java.lang.Runtime;
import java.lang.Process;
import java.util.*;
import java.io.*;



public class FloatSortRecord implements ExternalSortRecordI {

	float key;

	public ExternalSortRecordI clone() {
		return new FloatSortRecord( this );
	}

	public FloatSortRecord(int dim, Scanner s ) {
		key = s.nextFloat();
	}

	public FloatSortRecord( FloatSortRecord z ) {
		key = z.key;	
	}

	public FloatSortRecord(float f) {
		key = f;
	}

	// written size in bytes
	public int size() {
		return 4; 
	}

	public void write( DataOutput out ) throws IOException {
			out.writeFloat(key);
	}
	
	public void write( Writer w ) throws IOException {
		String s = Float.toString(key) + "\n";
		w.write(s);
	}

	public String toString() {
		return Float.toString(key);
	}

	public  void read( DataInput in ) throws IOException {
		key = in.readFloat();
	}


	public int compare( ExternalSortRecordI l, ExternalSortRecordI r ) {
		FloatSortRecord zl = (FloatSortRecord) l;
		FloatSortRecord zr = (FloatSortRecord) r;
		float sl = zl.key;
		float sr = zr.key;

		if( sl < sr ) return -1;
		else if( sl > sr ) return 1;
		else return 0;
	}

	public boolean equals( ExternalSortRecordI l, ExternalSortRecordI r ) {
		float sl = ((FloatSortRecord) l).key;
		float sr = ((FloatSortRecord) r).key;

		if( sl == sr ) return true;
		return false;
	}

}
