package sort;
import java.lang.Runtime;
import java.lang.Process;
import java.util.*;
import java.io.*;



public class ZorderSortRecord implements ExternalSortRecordI {

	String Zval;
	float[] coord;
	static int ZvalLength;

	public ExternalSortRecordI clone() {
		return new ZorderSortRecord( this );
	}

	public ZorderSortRecord(int dim, Scanner s ) {
		Zval = s.next();
		ZvalLength = Zval.length();

		try {
			coord = new float[dim];
			for( int i = 0; i < coord.length; ++i ) coord[i] = s.nextFloat();
		}
		catch( Exception e ) {}
	}

	public ZorderSortRecord( ZorderSortRecord z ) {
		Zval = new String( z.Zval );
		ZvalLength = z.ZvalLength;
		coord = new float[z.coord.length];
		for( int i = 0; i < z.coord.length; ++i ) coord[i] = z.coord[i];
		
	}

	public ZorderSortRecord( String z, float[] c) {
		Zval = new String( z );
		ZvalLength = Zval.length();

		coord = new float[c.length];
		for( int i = 0; i < c.length; ++i )
			coord[i] = c[i];
	}

	public ZorderSortRecord(int zlength, int dim) {
		Zval = "";
		ZvalLength = zlength;
		coord = new float[dim];
	}

	// written size in bytes
	public int size() {
		return 4 + ZvalLength + ( coord.length * 4 ); 
	}

	public void write( DataOutput out ) throws IOException {
			out.writeInt(ZvalLength);
			for( int i = 0; i < Zval.length(); ++i ) out.writeByte( Byte.valueOf( Character.toString(Zval.charAt(i)) ) );
			for( int i = 0; i < coord.length; ++i ) out.writeFloat(coord[i]);
	}
	
	public void write( Writer w ) throws IOException {
		//w.write( Integer.toString( ZvalLength ) );
		//w.write( " " + Zval );
		String s = "";
		for( int i = 0; i < coord.length; ++i ) s += ( " " + coord[i] );
		s = s.trim();
		w.write( s + "\n"); 
	}

	public String toString() {
		String s = "Zlength: " + ZvalLength + " Zval: " + Zval + " coord: ";
		for( int i = 0; i < coord.length; ++i ) s += ( " " + coord[i] );
		s += ("\n"); 
		return s;
	}

	public  void read( DataInput in ) throws IOException {
			Zval = "";
			ZvalLength = in.readInt();
			for( int i = 0; i < ZvalLength; ++ i ) Zval += in.readByte();
			for( int i = 0; i < coord.length; ++i ) coord[i] = in.readFloat();
	}


	public int compare( ExternalSortRecordI l, ExternalSortRecordI r ) {

		if( l == null || r == null ) System.out.println ("sthing wrong!!!");

		ZorderSortRecord zl = (ZorderSortRecord) l;
		ZorderSortRecord zr = (ZorderSortRecord) r;
		String sl = zl.Zval;
		String sr = zr.Zval;

		if( sl == null || sr == null ) System.out.println( "sthing wrong2!!!");

		return sl.compareTo(sr);
	}

	public boolean equals( ExternalSortRecordI l, ExternalSortRecordI r ) {
		String sl = ((ZorderSortRecord) l).Zval;
		String sr = ((ZorderSortRecord) r).Zval;

		return sl.equalsIgnoreCase(sr);
	}

}
