package sort;
import java.io.*;
import java.util.*;
import java.util.Date;
import java.util.Random;
import java.util.ArrayList;
import java.math.*;


public class zKernel {


	public static void toBinaryFile( String inFile, String outFile ) {
		final int bufferSize = 16 * 1024 * 1024;
		float val = 0;
		String line = "";

		try {
			BufferedReader rin = new BufferedReader(new FileReader(inFile),bufferSize);
			DataOutputStream dos = new DataOutputStream( new BufferedOutputStream( new FileOutputStream( outFile), bufferSize) );

			while( ( line = rin.readLine() ) != null ) {
				val = Float.valueOf(line);
				FloatSortRecord rec = new FloatSortRecord( val );
				rec.write(dos);

			}

			rin.close();
			dos.close();
		}
		catch(IOException e )
		{} 
	}



	public static void binaryToAsciiFile( int dimension, int k, ExternalSortRecordI extRec, String inFile, String outFile ) {
		final int bufferSize = 16 * 1024 * 1024;
		RandomAccessFile dis;
		BufferedWriter bw;
		long pos = 0;

		try {
			dis = new RandomAccessFile( inFile, "r" );
			bw = new BufferedWriter( new FileWriter( outFile ), bufferSize );


			try {
				extRec.read( dis );
				extRec.write( bw );
				long numRecords = (dis.length() / extRec.size() );
				long skipLength = (long) Math.floor( ( numRecords - k ) / ( k - 1 ) );

				System.out.println( "numRecs: " + numRecords );
				System.out.println( "skipLength: " + skipLength );
				skipLength *= extRec.size();

				while( true ) {
					//System.out.println( "read" );
					//System.out.println( dis.getFilePointer() );
					dis.seek( dis.getFilePointer() + skipLength );
					//System.out.println( dis.getFilePointer() + skipLength );
					extRec.read( dis );
					extRec.write( bw );
				}
			}
			catch( Exception e ) {}

			dis.close();
			bw.close();

		}
		catch( Exception e ) {}
	}

	public static void main(String[] args) throws Exception{

		if( args.length < 4 ) {
			System.out.println( "usage: <dimension> <infile> <outfile> <blocksize (MB)> <k> [shiftfile]" );
			return;
		}




		int dimension = Integer.valueOf( args[0] );
		String infile = args[1];
		String outfile = args[2];
                int size = Integer.valueOf(args[3]);
		int k = Integer.valueOf( args[4] );
		String shiftFile = args.length == 6 ? args[5] : null;

		long runtime = 0;

		if( dimension == 1 ) {
			toBinaryFile( infile, "tempfile" );
			runtime = System.currentTimeMillis();
			ExternalSort2.externalSort( "tempfile", "tempfile.s", size, new FloatSortRecord(0f) );
			binaryToAsciiFile( dimension, k, new FloatSortRecord(0f), "tempfile.s", outfile );
			runtime = System.currentTimeMillis() - runtime;
		}

		else {
			Zorder.toBinaryZvalFile( dimension, infile, "tempfile", shiftFile );
			runtime = System.currentTimeMillis();
			ExternalSort2.externalSort( "tempfile", "tempfile.s", size, new ZorderSortRecord(0, dimension) );
			Zorder.binaryToAsciiFile(dimension,0,k,"tempfile.s",outfile);
			runtime = System.currentTimeMillis() - runtime;
		}

		System.out.println( "Runtime: " + runtime );

	}
}
